<?php
/**
* @version $Id: admin.gmapscoords_init.php
* @package: Google Maps Coordinates Plugin for Sigsiu Online Business Index 2
* ===================================================
* @author
* Name: Piotr Moko
* Url: http://www.perfect-web.pl
* ===================================================
* @copyright Copyright (C) 2010 Perfect-Web (http://www.perfect-web.pl). All rights reserved.
* @license see http://www.gnu.org/copyleft/gpl.html GNU/GPL.
* The Google Maps Coordinates Plugin is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation.
*/
defined( '_SOBI2_' ) || exit("Restricted access");

class sobi_gmapscoords_adm extends sobi_gmapscoords {
/*
 *
 * ************************************************************
 * required methods
 * ************************************************************
 */
 
	public function customTask($sobi2Task) {
		$sgssid = sobi2Config::request( $_REQUEST, "sgssid");
		$return = false;
		switch($sobi2Task) {
			case 'adminGmapscoordsForm':
				$this->checkSession($sgssid);
				$this->formGMpas((int) sobi2Config::request( $_REQUEST, "sobi2Id", 0),$sgssid);
				$return = true;
				break;
			default:
				$return = false;
				break;
		}
		return $return;
    }

	public function saveConfig() {
    	$config =& adminConfig::getInstance();
    	$config->setValueInDB(floatval(sobi2Config::request( $_POST, 'latitude',$this->latitude )),"gm_latitude","GMapsCoords");
    	$config->setValueInDB(floatval(sobi2Config::request( $_POST, 'longitude', $this->longitude )),"gm_longitude","GMapsCoords");
    	$config->setValueInDB(intval(sobi2Config::request( $_POST, 'zoom',$this->zoom )),"gm_zoom","GMapsCoords");
    	$config->setValueInDB(intval(sobi2Config::request( $_POST, 'fpos', $this->fpos )),"gm_fpos","GMapsCoords");
    	$config->setValueInDB(intval(sobi2Config::request( $_POST, 'framewidth', $this->frameWidth )),"gm_frameWidth","GMapsCoords");
    	$config->setValueInDB(intval(sobi2Config::request( $_POST, 'frameheight', $this->frameHeight )),"gm_frameHeight","GMapsCoords");
    	$config->setValueInDB(intval(sobi2Config::request( $_POST, 'disableWarnings', $this->disableWarnings )),"gm_disableWarnings","GMapsCoords");
		
		$fieldLatitudeId = $config->getValueFromDB("google","googleMapsLatField");
		$fieldLongitudeId = $config->getValueFromDB("google","googleMapsLongField");
		
		if ($_POST['fieldGpsLatitudeId'] == $fieldLatitudeId or $_POST['fieldGpsLatitudeId'] == $fieldLongitudeId) {	
			$_POST['fieldGpsLatitudeId'] = 0;
		}
		$config->setValueInDB(floatval(sobi2Config::request( $_POST, 'fieldGpsLatitudeId',$this->fieldGpsLatitudeId )),"gm_fieldGpsLatitude","GMapsCoords");
		
		if ($_POST['fieldGpsLongitudeId'] == $fieldLatitudeId or $_POST['fieldGpsLongitudeId'] == $fieldLongitudeId) {
			$_POST['fieldGpsLongitudeId'] = 0;
		}
		$config->setValueInDB(floatval(sobi2Config::request( $_POST, 'fieldGpsLongitudeId', $this->fieldGpsLongitudeId )),"gm_fieldGpsLongitude","GMapsCoords");
    }

    public function config() {
		
		$config =& adminConfig::getInstance();
		$database =& $config->getDb();
		
		if ($this->disableWarnings == 0) {
			//check API key
			if (strlen($config->getValueFromDB("google","googleMapsApiKey")) < 2) {
				JError::raiseWarning( 100, 'Set Google Maps API Key in <a href="index2.php?option=com_sobi2&task=viewConf">SOBI Google Maps Configuration</a>' );
			}
			
			$fieldLatitudeId = $config->getValueFromDB("google","googleMapsLatField");
			$fieldLongitudeId = $config->getValueFromDB("google","googleMapsLongField");
			
			if ($fieldLatitudeId > 0 and $fieldLongitudeId > 0) {
				//wrong fields for latitude and longitude in GPS format
				if ($this->fieldGpsLatitudeId == $fieldLatitudeId or $this->fieldGpsLatitudeId == $fieldLongitudeId or
					$this->fieldGpsLongitudeId == $fieldLatitudeId or $this->fieldGpsLongitudeId == $fieldLongitudeId) {
						
					$this->fieldGpsLatitudeId = 0;
					$this->fieldGpsLongitudeId = 0;
					JError::raiseWarning(100, 'Fields for latitude and longitude in GPS format can not be the same as fields for latitude and longitude in decimal format set in SOBI Google Maps Configuration');
				}
				
				//are fields published and public
				$query = "SELECT f.enabled, f.displayed AS admin, l.langKey, l.langValue FROM `#__sobi2_fields` f LEFT JOIN `#__sobi2_language` l ON l.fieldid = f.fieldid WHERE f.fieldid IN ($fieldLatitudeId, $fieldLongitudeId, 1, 3".
				($this->fieldGpsLatitudeId > 0 ? ', '.$this->fieldGpsLatitudeId : '').
				($this->fieldGpsLongitudeId > 0 ? ', '.$this->fieldGpsLongitudeId : '').
				") AND l.sobi2Section = 'fields' AND l.sobi2Lang = 'english' ORDER BY f.fieldid";
				$database->setQuery( $query );
				$requiredFields = $database->loadObjectList();
				if ($database->getErrorNum()) {
					trigger_error("DB reports: ".$database->stderr(), E_USER_WARNING);
				}
				$enableNotice = array();
				$adminNotice = array();
				
				foreach($requiredFields as $field) {
					if ($field->enabled == 0) {
						$enableNotice[] = $field->langValue.' ('.$field->langKey.')';
					}
					if ($field->admin == 1) {
						$adminNotice[] = $field->langValue.' ('.$field->langKey.')';
					}
				}
				if (count($enableNotice) > 0) {
					JError::raiseNotice(100, 'Enable fields: '.implode(', ', $enableNotice).' in <a href="index2.php?option=com_sobi2&task=editFields">SOBI Custom Fields Manager</a>');
				}
				if (count($adminNotice) > 0) {
					JError::raiseNotice(100, 'Set fields: '.implode(', ', $adminNotice).' as public in <a href="index2.php?option=com_sobi2&task=editFields">SOBI Custom Fields Manager</a>');
				}
				
				//recommended field position
				$query = "SELECT f.position FROM `#__sobi2_fields` f WHERE f.fieldid IN ($fieldLatitudeId, $fieldLongitudeId) ORDER BY f.position ASC LIMIT 1";
				$database->setQuery( $query );
				$fieldPos = $database->loadResult();
				if ($this->fPos != $fieldPos) {
					JError::raiseNotice(100, 'Recommended plugin field position is '.$fieldPos);
				}
			} else {
				//latitude or longituted fields not selected
				JError::raiseWarning(100, 'Set Map Latitude and Longitude Fields in <a href="index2.php?option=com_sobi2&task=viewConf">SOBI Google Maps Configuration</a>');
			}
		}
    ?>
	<table class="SobiAdminForm" width="100%">
		<tr>
			<th style="text-align:left; width: 100%;"><?php echo _GMAPSCOORDS_ADMIN_TITLE; ?></th>
		</tr>
	</table>

	<table class="SobiAdminForm" width="100%">

	<tr class="row0">
      <td valign="top" width="20%">
      	<span class="editlinktip">
      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_LAT_EXPL),addslashes(_GMAPSCOORDS_ADMIN_LAT),'','',_GMAPSCOORDS_ADMIN_LAT, '#',0 );?>
      	</span>
      </td>
      <td valign="top" width="80%"><input type="text" class="text_area" style="text-align:center;" name="latitude" value="<?php echo $this->latitude ?>" size="20" maxlength="100"/></td>
    </tr>
	
	<tr class="row1">
      <td valign="top" width="20%">
      	<span class="editlinktip">
      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_LONG_EXPL),addslashes(_GMAPSCOORDS_ADMIN_LONG),'','',_GMAPSCOORDS_ADMIN_LONG, '#',0 );?>
      	</span>
      </td>
      <td valign="top" width="80%"><input type="text" class="text_area" style="text-align:center;" name="longitude" value="<?php echo $this->longitude ?>" size="20" maxlength="100"/></td>
    </tr>

    <tr class="row0">
      <td valign="top" width="20%">
      	<span class="editlinktip">
      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_ZOOM_EXPL),addslashes(_GMAPSCOORDS_ADMIN_ZOOM),'','',_GMAPSCOORDS_ADMIN_ZOOM, '#',0 );?>
      	</span>
      </td>
      <td valign="top" width="80%">
	  <?php
      		$zoomSelect = array();
      		for($i = 1; $i <= 19; $i++)
      			$zoomSelect[] = sobiHTML::makeOption( $i, $i);
      		echo sobiHTML::selectList( $zoomSelect, 'zoom', 'size="1" class="inputbox"', 'value', 'text', $this->zoom);
      	?>
    </tr>
	
	<tr class="row1">
		<td width="20%">
	      	<span class="editlinktip">
	      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_GPS_LAT_EXPL),addslashes(_GMAPSCOORDS_ADMIN_GPS_LAT),'','',_GMAPSCOORDS_ADMIN_GPS_LAT, '#',0 );?>
	      	</span>
		</td>
		<td width="80%">
			<?php echo $config->getExistingFieldsList($this->fieldGpsLatitudeId, 'fieldGpsLatitudeId'); ?>
		</td>
	</tr>
	
	<tr class="row0">
		<td width="20%">
	      	<span class="editlinktip">
	      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_GPS_LONG_EXPL),addslashes(_GMAPSCOORDS_ADMIN_GPS_LONG),'','',_GMAPSCOORDS_ADMIN_GPS_LONG, '#',0 );?>
	      	</span>
		</td>
		<td width="80%">
			<?php echo $config->getExistingFieldsList($this->fieldGpsLongitudeId, 'fieldGpsLongitudeId'); ?>
		</td>
	</tr>
	
	<tr class="row1">
		<td width="20%">
	      	<span class="editlinktip">
	      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_FPOS_EXPL),addslashes(_GMAPSCOORDS_ADMIN_FPOS),'','',_GMAPSCOORDS_ADMIN_FPOS, '#',0 );?>
	      	</span>
		</td>
		<td width="80%">
			<input type="text" class="text_area" style="text-align:center;" name="fpos" value="<?php echo $this->fPos ?>" size="5" maxlength="5"/>
		</td>
	</tr>
	
	<tr class="row0">
		<td width="20%">
	      	<span class="editlinktip">
	      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_FRAME_WIDTH_EXPL),addslashes(_GMAPSCOORDS_ADMIN_FRAME_WIDTH),'','',_GMAPSCOORDS_ADMIN_FRAME_WIDTH, '#',0 );?>
	      	</span>
		</td>
		<td width="80%">
			<input type="text" class="text_area" style="text-align:center;" name="framewidth" value="<?php echo $this->frameWidth ?>" size="5" maxlength="5"/>
		</td>
	</tr>
	
	<tr class="row1">
		<td width="20%">
	      	<span class="editlinktip">
	      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_FRAME_HEIGHT_EXPL),addslashes(_GMAPSCOORDS_ADMIN_FRAME_HEIGHT),'','',_GMAPSCOORDS_ADMIN_FRAME_HEIGHT, '#',0 );?>
	      	</span>
		</td>
		<td width="80%">
			<input type="text" class="text_area" style="text-align:center;" name="frameheight" value="<?php echo $this->frameHeight ?>" size="5" maxlength="5"/>
		</td>
	</tr>
	
	<tr class="row0">
		<td width="20%">
	      	<span class="editlinktip">
	      		<?php echo sobiHTML::toolTip(addslashes(_GMAPSCOORDS_ADMIN_DISABLE_WARNINGS_EXPL),addslashes(_GMAPSCOORDS_ADMIN_DISABLE_WARNINGS),'','',_GMAPSCOORDS_ADMIN_DISABLE_WARNINGS, '#',0 );?>
	      	</span>
		</td>
		<td width="80%">
			<?php echo sobiHTML::yesnoRadioList( 'disableWarnings', 'class="inputbox"', $this->disableWarnings ); ?>
		</td>
	</tr>
	
	<tr class="row1">
		<td width="20%">
	      	<?php echo _GMAPSCOORDS_ADMIN_INFO; ?>
		</td>
		<td width="80%">
			<?php echo _GMAPSCOORDS_ADMIN_ENTRY_FORM_TPL; ?>:<br/>
<span style="color:red">&lt;?php</span> <span style="color:navy">$pluginsObjects</span><span style="color:purple">[<span style="color:grey">'gmapscoords'</span>]-></span><span style="color:black">editFormStart</span><span style="color:purple">(<span style="color:orange">1</span>, <span style="color:navy">$fields</span>);</span><br/>
<span style="color:blue">echo</span> <span style="color:navy">$fields</span><span style="color:purple">[<span style="color:grey">'gmapscoords_plugin'</span>][<span style="color:grey">'field'</span>];</span> <span style="color:red">?&gt;</span>
		</td>
	</tr>

	</table>
	<br /><br />
	
    <?php
    }
/*
 *
 * ************************************************************
 * free definied methods
 * ************************************************************
 */
    public function sobi_gmapscoords_adm() {
    	$this->sobi_gmapscoords(true);
		$this->formName = 'adminForm';
    }

   
/* End of Class */
}
?>