<?php
/**
* @version $Id: gmapscoords.class.php
* @package: Google Maps Coordinates Plugin for Sigsiu Online Business Index 2
* ===================================================
* @author
* Name: Piotr Moćko
* Url: http://www.perfect-web.pl
* ===================================================
* @copyright Copyright (C) 2010 Perfect-Web (http://www.perfect-web.pl). All rights reserved.
* @license see http://www.gnu.org/copyleft/gpl.html GNU/GPL.
* The Google Maps Coordinates Plugin is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation.
*/
defined( '_SOBI2_' ) || exit("Restricted access");

class sobi_gmapscoords {

/*
 *
 * ************************************************************
 * required attributes
 * ************************************************************
 */
	public $name = "Google Maps Coordinates";
	public $listingStyle = "gmapscoords_form";

/*
 *
 * ************************************************************
 * free definied attributes
 * ************************************************************
 */
	public $fPos 					= 6;
	public $apiKey 					= null;
	public $disableWarnings 		= 0;
	public $latitude				= 50;
	public $longitude				= -30;
	public $zoom					= 2;
	public $formName				= 'sobi2EditForm';
	public $formFieldLatitude 		= 'field_latitude';
	public $formFieldLongitude 		= 'field_longitude';
	public $fieldGpsLatitudeId		= 0;
	public $fieldGpsLongitudeId		= 0;
	public $formFieldGpsLatitude 	= null;
	public $formFieldGpsLongitude 	= null;
	public $frameWidth				= 620;
	public $frameHeight				= 580;

/*
 * ************************************************************
 * required methods
 * ************************************************************
 */

    public function customTask($sobi2Task) {
		$sgssid = sobi2Config::request( $_REQUEST, "sgssid");
		$return = false;
		switch($sobi2Task) {
			case 'gmapscoordsForm':
				$this->checkSession($sgssid);
				$this->formGMpas((int) sobi2Config::request( $_REQUEST, "sobi2Id", 0),$sgssid);
				$return = true;
				break;
			default:
				$return = false;
				break;
		}
		return $return;
    }

	public function editFormStart($sobi2Id,&$fields) {

		if ($this->fPos > 0) {
			$config =& sobi2Config::getInstance();
			$dummy = new stdClass();
			$dummy->label = '';
			$dummy->fieldname = 'gmapscoords_plugin';
			$dummy->is_free = true;
			$dummy->fieldType = 4;
			$dummy->wysiwyg = false;
			$dummy->payment = 0;
			$dummy->customCode = $this->editForm($sobi2Id);
			$dummy->is_required = false;
			$this->fPos = $this->fPos - 1;
			$newArray = array();
			$c = 0;
			
			foreach ($fields as $key => $field) {
				if($c == $this->fPos) {
					define("_SGMAPCOORDDS_LINK_ADDED",1);
					$newArray['gmapscoords'] = $dummy;
					$c++;
				}
				$newArray[$key] = $field;
				$c++;
			}
			if(!defined("_SGMAPCOORDDS_LINK_ADDED")) {
				define("_SGMAPCOORDDS_LINK_ADDED",1);
				$newArray['gmapscoords'] = $dummy;
			}
			$fields = $newArray;
		}
	}

    public function showDetails($sobi2Id) {
		return null;
    }


    public function editForm($sobi2Id) {
		if(defined("_SGMAPCOORDDS_LINK_ADDED") || !$this->fPos ) {
			return null;
		}
		
		JHTML::_('behavior.mootools');
		JHTML::_('behavior.modal');
		
    	$config =& sobi2Config::getInstance();

		$doc =& JFactory::getDocument();
		$doc->addScript('http://api-maps.yandex.ru/2.0/?load=package.full&lang=ru-RU');
		if ($this->fieldGpsLatitudeId > 0 || $this->fieldGpsLongitudeId > 0) {
			$doc->addScript($config->liveSite.'/components/com_sobi2/plugins/gmapscoords/js/GMapsCoordinates.js');
		}
		
		@session_name('_SGMAPCOORDDS_VALID');
		@session_start();
		$ssid = session_id();
		
    	if ($this->formName == 'sobi2EditForm') {
			$href = "{$config->liveSite}/index.php?option=com_sobi2&amp;sobi2Task=gmapscoordsForm&amp;sobi2Id={$sobi2Id}&amp;sgssid={$ssid}&amp;tmpl=component";
		}
		else if ($this->formName == 'adminForm') {
			$href = "{$config->liveSite}/administrator/index3.php?option=com_sobi2&amp;sobi2Task=adminGmapscoordsForm&amp;sobi2Id={$sobi2Id}&amp;sgssid={$ssid}";
		} else {
			return null;
		}
		
		ob_start(); 
?>
var geocoder;

function GMapCoords_isExisting(obj){
  return typeof(obj)!='undefined';
}

function GMapCoords_getAddress() {
	
	var address = '';
	
	if (GMapCoords_isExisting(f_street = document.forms.<?php echo $this->formName;?>.elements.field_street)) {
		address = f_street.value;
	}
	if (GMapCoords_isExisting(f_postcode = document.forms.<?php echo $this->formName;?>.elements.field_postcode)) {
		address += ' ' + f_postcode.value;
	}
	if (GMapCoords_isExisting(f_city = document.forms.<?php echo $this->formName;?>.elements.field_city)) {
		address += ' ' + f_city.value;
	}
	if (GMapCoords_isExisting(f_federal_state = document.forms.<?php echo $this->formName;?>.elements.field_federal_state)) {
		if (f_federal_state.value != 0) {
			address += ' ' + f_federal_state.value;
		}
	}  	 
	if (GMapCoords_isExisting(f_country = document.forms.<?php echo $this->formName;?>.elements.field_country)) {
		address += ' ' + f_country.value;
	}
	
	if ( address.match(/^(\s)+$/) ) {
		alert('<?php echo _GMAPSCOORDS_NO_ADDRESS;?>');
		return false;
	}
	return address;
}

function GMapCoords_getCoords(address) {
	
		ymaps.geocode(address, {results: 1}).then(function (res) {
		var firstGeoObject = res.geoObjects.get(0);
		if(firstGeoObject) {
				var point = firstGeoObject.geometry.getCoordinates();
				document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldLatitude; ?>.value = firstGeoObject.geometry.getCoordinates()[0];
				document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldLongitude; ?>.value = firstGeoObject.geometry.getCoordinates()[1];
				<?php if ($this->fieldGpsLatitudeId > 0) : ?>
				latitudeValue = GMapCoords_convertGPS(point.lat(), 'latitude');
				document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldGpsLatitude; ?>.value = latitudeValue;
				<?php endif; ?>
				<?php if ($this->fieldGpsLongitudeId > 0) : ?>
				longitudeValue = GMapCoords_convertGPS(point.lng(), 'longitude');
				document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldGpsLongitude; ?>.value = longitudeValue;
				<?php endif; ?>
			} else {
				alert('<?php echo _GMAPSCOORDS_ADDRESS_NOT_FOUND;?>: '+address);
			}
		});
	
	return true;
}

window.addEvent('domready', function(){
	
	$('GMapCoords_GetCoords').addEvent('click', function(e) {
		new Event(e).stop();
		var result;
		var address = GMapCoords_getAddress();
		if (address != false) result = GMapCoords_getCoords(address);
	});
	
	$('GMapCoords_ShowMap').addEvent('click', function(e) {
		new Event(e).stop();
		var result = true;
		var latitudeValue = parseFloat(document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldLatitude; ?>.value);
		var longitudeValue = parseFloat(document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldLongitude; ?>.value);
		
		if (isNaN(latitudeValue) || isNaN(longitudeValue)) {
			var address = GMapCoords_getAddress();
			if (address != false) {
				result = GMapCoords_getCoords(address);
			}
		}
		if (result) {
			SqueezeBox.fromElement(this); 
		}
	});
	
	//geocoder = new google.maps.Geocoder();
	document.getElementById('gmapcoords_controls').style.visibility = 'visible';
});
<?php
		$script = ob_get_contents();
		ob_end_clean();
		$doc->addScriptDeclaration($script);
		
		$form =  '<div id="gmapcoords_controls" style="visibility:hidden">'
				.'<a href="#" id="GMapCoords_GetCoords">'._GMAPSCOORDS_GET_COORDS.'</a>'
				." | <a href=\"{$href}\" id=\"GMapCoords_ShowMap\" rel=\"{handler: 'iframe', size: {x:{$this->frameWidth}, y:{$this->frameHeight}}}\">"._GMAPSCOORDS_SHOW_MAP.'</a>'
				.'</div>';

    	return $form;
    }
    /*
     * $input['fees']
     * $input['msg']                         Reference         Payment
     * adding fees: $input['fees'] += array("test"      =>     10);
     */
    public function save($input,$sobi2Id,$actionSwitch='save') {
		return null;
    }
    /*
     * $input['fees']
     * $input['msg']                         Reference         Payment
     * adding fees: $input['fees'] += array("test"      =>     10);
     */
    public function update($input,$sobi2Id) {
		return null;
    }

	/*
     * $input['fees']
     * $input['msg']                         Reference         Payment
     * adding fees: $input['fees'] += array("test"      =>     10);
     */
    public function renew($input,$sobi2Id) {
		return null;
    }
	
    public function showListing($sobi2Id) {
		return null;
    }

    public function replaceMarkers($string) {
    	return $string;
    }
/*
 *
 * ************************************************************
 * free defined methods
 * ************************************************************
 */
    public function sobi_gmapscoords() {
			
		$config =& sobi2Config::getInstance();
		$database =& $config->getDb();
		
		$this->apiKey = $config->getValueFromDB("google","googleMapsApiKey");
		$this->disableWarnings = $config->getValueFromDB("GMapsCoords","gm_disableWarnings");
		
		$fieldLatitudeId = $config->getValueFromDB("google","googleMapsLatField");
		if ($fieldLatitudeId > 0) {
			$query = "SELECT DISTINCT langKey FROM `#__sobi2_language` WHERE fieldid='$fieldLatitudeId' LIMIT 1";
			$database->setQuery( $query );
			$field = $database->loadResult();
			if ($database->getErrorNum()) {
				trigger_error("DB reports: ".$database->stderr(), E_USER_WARNING);
			}
			$this->formFieldLatitude = $field;
			
			
			$this->fieldGpsLatitudeId = $config->getValueFromDB("GMapsCoords","gm_fieldGpsLatitude");
			if ($this->fieldGpsLatitudeId == $fieldLatitudeId) {
				$this->fieldGpsLatitudeId = 0;
			}
			if ($this->fieldGpsLatitudeId > 0) {
				$query = "SELECT DISTINCT langKey FROM `#__sobi2_language` WHERE fieldid='$this->fieldGpsLatitudeId' LIMIT 1";
				$database->setQuery( $query );
				$field = $database->loadResult();
				if ($database->getErrorNum()) {
					trigger_error("DB reports: ".$database->stderr(), E_USER_WARNING);
				}
				$this->formFieldGpsLatitude = $field;
			} 
		}
		
		$fieldLongitudeId = $config->getValueFromDB("google","googleMapsLongField");
		if ($fieldLongitudeId > 0) {
			$query = "SELECT DISTINCT langKey FROM `#__sobi2_language` WHERE fieldid='$fieldLongitudeId' LIMIT 1";
			$database->setQuery( $query );
			$field = $database->loadResult();
			if ($database->getErrorNum()) {
				trigger_error("DB reports: ".$database->stderr(), E_USER_WARNING);
			}
			$this->formFieldLongitude = $field;
			
			
			$this->fieldGpsLongitudeId = $config->getValueFromDB("GMapsCoords","gm_fieldGpsLongitude");
			if ($this->fieldGpsLongitudeId == $fieldLongitudeId) {
				$this->fieldGpsLongitudeId = 0;
			}
			if ($this->fieldGpsLongitudeId > 0) {
				$query = "SELECT DISTINCT langKey FROM `#__sobi2_language` WHERE fieldid='$this->fieldGpsLongitudeId' LIMIT 1";
				$database->setQuery( $query );
				$field = $database->loadResult();
				if ($database->getErrorNum()) {
					trigger_error("DB reports: ".$database->stderr(), E_USER_WARNING);
				}
				$this->formFieldGpsLongitude = $field;
			}
		}
		
    	$this->latitude = $config->getValueFromDB("GMapsCoords","gm_latitude");
    	$this->longitude = $config->getValueFromDB("GMapsCoords","gm_longitude");
    	$this->zoom = $config->getValueFromDB("GMapsCoords","gm_zoom");
    	$this->fPos = $config->getValueFromDB("GMapsCoords","gm_fpos");
    	$this->frameWidth = $config->getValueFromDB("GMapsCoords","gm_framewidth");
    	$this->frameHeight = $config->getValueFromDB("GMapsCoords","gm_frameheight");
    }
	
    public function checkSession($sgssid) {
	
		$config =& sobi2Config::getInstance();
    	session_name('_SGMAPCOORDDS_VALID');
		@session_start();
    	$ssid = session_id();
    	if(!$sgssid) {
    		 die( 'Restricted access' );
    	}
   }
   
   public function formGMpas($sobi2Id, $sgssid) {
		
		JHTML::_('behavior.mootools');
			
		$config =& sobi2Config::getInstance();
		
		$doc =& JFactory::getDocument();
		$doc->addStyleSheet($config->liveSite.'/components/com_sobi2/plugins/gmapscoords/css/GMapsCoordinates.css');
		$doc->addScript('http://api-maps.yandex.ru/2.0/?load=package.full&lang=ru-RU');
		if ($this->fieldGpsLatitudeId > 0 || $this->fieldGpsLongitudeId > 0) {
			$doc->addScript($config->liveSite.'/components/com_sobi2/plugins/gmapscoords/js/GMapsCoordinates.js');
		}
		
		$mooVer111 = true;
		if (version_compare(JVERSION, '1.5', '>=') && version_compare(JVERSION, '1.6', '<')) {
			if (JFactory::getApplication()->get('MooToolsVersion', '1.11') != '1.11') $mooVer111 = false;
		}


?><div id="gmapscoords_frame">
	<div id="gmapscoords_msg" style="width:<?php echo $this->frameWidth-20; ?>px"><div><?php echo _GMAPSCOORDS_SET_COORDS;?></div></div>
	<div id="gmapscoords_map" style="width:<?php echo $this->frameWidth-20; ?>px; height:<?php echo $this->frameHeight-20; ?>px;"></div>
</div>
<script type="text/javascript">//<![CDATA[
var GMapCoords_msgtTimerId = 0;
var GMapCoords_msgFx;

function GMapCoords_hideMsg() {
	<?php if ($mooVer111) : ?>
	GMapCoords_msgFx.start(0);
	<?php else : ?>
	GMapCoords_msgFx.start('opacity', 0);
	<?php endif; ?>
}

function GMapCoords_setLocation(latitude, longitude) {

	window.top.document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldLatitude; ?>.value = latitude;
	window.top.document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldLongitude; ?>.value = longitude;
	
	<?php if ($this->fieldGpsLatitudeId > 0) :
	?>latitudeGPS = GMapCoords_convertGPS(latitude, 'latitude');
	window.top.document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldGpsLatitude; ?>.value = latitudeGPS;
	<?php endif;
	if ($this->fieldGpsLongitudeId > 0) :
	?>longitudeGPS = GMapCoords_convertGPS(longitude, 'longitude');
	window.top.document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldGpsLongitude; ?>.value = longitudeGPS;
	<?php endif; ?>
	
	clearTimeout(GMapCoords_msgtTimerId);
	<?php if ($mooVer111) : ?>
	GMapCoords_msgFx.start(1);
	<?php else : ?>
	GMapCoords_msgFx.start('opacity', 1);
	<?php endif; ?>
	GMapCoords_msgtTimerId = setTimeout("GMapCoords_hideMsg()", 3000);
}

window.addEvent('domready', function() {
	
	var map;
	var mapOptions;
	var marker;
	var latitudeValue = parseFloat(window.top.document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldLatitude; ?>.value);
	var longitudeValue = parseFloat(window.top.document.forms.<?php echo $this->formName;?>.elements.<?php echo $this->formFieldLongitude; ?>.value);
	var location;
	var zoom = <?php echo $this->zoom;?>;
	
	<?php if ($mooVer111) : ?>
	GMapCoords_msgFx = new Fx.Style('gmapscoords_msg', 'opacity', {wait: false}).set(0);
	<?php else : ?>
	GMapCoords_msgFx = new Fx.Tween('gmapscoords_msg', {link: 'cancel'}).set('opacity', 0);
	<?php endif; ?>
	$('gmapscoords_msg').setStyle('display','block');
	
	if (isNaN(latitudeValue) || isNaN(longitudeValue)) {
		location = [<?php echo $this->latitude; ?>, <?php echo $this->longitude; ?>];
	} else {
		location =  [latitudeValue, longitudeValue];
		zoom = 16;
	}
	
	map = new ymaps.Map("gmapscoords_map", {center: location, zoom: zoom}),

myPlacemark = new ymaps.Placemark(location,{}, {preset: "twirl#redIcon", draggable: true});

map.geoObjects.add(myPlacemark);
map.controls.add("smallZoomControl").add("typeSelector").add("mapTools");
myPlacemark.events.add("dragend", function (e) {
var coords =  this.geometry.getCoordinates();
GMapCoords_setLocation(this.geometry.getCoordinates()[0], this.geometry.getCoordinates()[1]);
},myPlacemark);
});
//]]></script>
<?php
	}		
}
?>